package com.genuitec.sapphire.integratededitor.model;

import org.eclipse.sapphire.Element;
import org.eclipse.sapphire.ElementType;
import org.eclipse.sapphire.modeling.xml.annotations.XmlBinding;
import org.eclipse.sapphire.ListProperty;
import org.eclipse.sapphire.ElementList;
import org.eclipse.sapphire.Type;
import org.eclipse.sapphire.modeling.xml.annotations.XmlListBinding;

import com.genuitec.sapphire.integratededitor.annotations.IntegratedListBinding;

@XmlBinding(path = "resources")
public interface IAndroidResources extends Element {

	ElementType TYPE = new ElementType(IAndroidResources.class);
	
	// *** Colors ***
	@Type(base = IColor.class)
	@XmlListBinding(mappings = @XmlListBinding.Mapping(element = "color", type = IColor.class))
	ListProperty PROP_COLORS = new ListProperty(TYPE, "Colors"); //$NON-NLS-1$

	ElementList<? extends IColor> getColors();
	
	// *** Strings ***
	@Type(base = IString.class)
	@IntegratedListBinding //Marker annotation detecting that custom storage should be used 
	@XmlListBinding(mappings = @XmlListBinding.Mapping(element = "string", type = IString.class))
	ListProperty PROP_STRINGS = new ListProperty(TYPE, "Strings"); //$NON-NLS-1$

	ElementList<? extends IString> getStrings();
}
